<?php
/* 
 +---------------------------------------------------------------------------+
 | iobloggo.php                                                              |
 +---------------------------------------------------------------------------+
 | iobloggo.com importer for wordpress (http://www.wordpress.org)            |            
 | Version 2.0 (Beta) - Mon, 3 July 2006 13.45.46 GMT                        |
 |                                                                           | 
 | Copyright (C) 2005 by Marco Borromeo - me@ilborro.info                    |
 | This program uses PclZip (PhpConcept Library Zip) by Vincent Blavet       |
 | http://www.phpconcept.net/pclzip                                          | 
 +---------------------------------------------------------------------------+
 |                                                                           |
 | This program is free software; you can redistribute it and/or             |
 | modify it under the terms of the GNU General Public License               |
 | as published by the Free Software Foundation; either version 2            |
 | of the License, or (at your option) any later version.                    |
 |                                                                           |
 | This program is distributed in the hope that it will be useful,           |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 | GNU General Public License for more details.                              |
 |                                                                           |
 | You should have received a copy of the GNU General Public License         |
 | along with this program; if not, write to the Free Software Foundation,   |
 | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
 |                                                                           |
 +---------------------------------------------------------------------------+
 | See the readme.txt for more information on installation.                  |
 +---------------------------------------------------------------------------+
*/

require_once("pclzip.lib.php"); // Thanks Vincent! :-)

class IoBloggo_Import {

  var $post_step = 200;
  var $comments_step = 200;
  var $trackbacks_step = 200;
  
  var $users = array();
  var $categories = array();
  var $post2cat = array();
  var $posts = array();
  
  var $totalposts = 0;
  
  function header() {
		echo '<div class="wrap">';
		echo '<h2>'.__('Import da IoBloggo').'</h2>';
	}
	
	function footer() {
		echo '</div>';
	}
	
	function preparetext($string) {
    return preg_replace('/[^\x00-\x7F]/e', '"&#".ord("$0").";"', $string);
  }
	
	function formatuploadeddata($text)
  {
     $text = preg_replace("(\r\n)", "", $text);
     $text = preg_replace("(\r)", "", $text);
     $text = preg_replace("(\n)", "", $text);
     $text = preg_replace("(\"\";)", "\" \";", $text);
     $text = preg_replace("(\"\")", "\"\n\"", $text);
     return $text;
  }

	function getuploadeddata() {
	  $buffer = "";
	  
    $handle = fopen($this->file, "rb");
    if ($handle) {
      while (!feof($handle)) {
         $buffer .= fgets($handle, 4096);
      }
      fclose($handle);
    }
    
    $buffer = $this->formatuploadeddata($buffer, "");
    
    return $buffer;
  }
	
	function greet() {
		echo '<p>'.__('Questo importer ti permette di trasportare il tuo blog su IoBloggo verso Wordpress<br />Per iniziare, seleziona il tuo file .zip di esportazione da IoBloggo, e clicca su Importa.').'</p>';
		wp_import_upload_form("?import=iobloggo&amp;step=1");
		echo '<br /><p><i>'.__('Per gestire i files .zip, &#232 stata usata <a href=\'http://www.phpconcept.net/pclzip\'>PclZip (PhpConcept Library Zip) by Vincent Blavet</a>').'</i></p>';
	}
	
  function import_users() {
    
    $tusers = explode("\n", $this->getuploadeddata());
    
    for ($i = 1; $i < count($tusers); $i++) {
      list ($original_id, $loginname, $nickname, $email, $url, $permissions) = explode("\";\"", $tusers[$i]);
      $original_id = trim($original_id, "\"");
      $loginname = trim($loginname, "\"");
      $user_id = username_exists($loginname);
      if (!$user_id) {
        $pass = substr(md5(uniqid(microtime())), 0, 6);
        $user_id = wp_create_user($loginname, $pass);
        $this->users[$original_id] = $user_id;
      } else {
        $this->users[$original_id] = $user_id;
      }
    }
    
    echo '<p>'.__('Utenti importati...').'</p>';
	}

  function import_categories() {
    		
    $tcategories = explode("\n", $this->getuploadeddata());
    
    for ($i = 1; $i < count($tcategories); $i++) {
      list ($original_id, $catname, $show, $desc, $order) = explode("\";\"", $tcategories[$i]);
      $original_id = trim($original_id, "\"");
      $catname = $this->preparetext(trim($catname, "\""));
      if ($newid = category_exists($catname)) {
        $this->categories[$original_id] = $newid;
      } else {
        $newid = wp_create_category($catname);
        $this->categories[$original_id] = $newid;
      }
    }
    
    echo '<p>'.__('Categorie importate...').'</p>';
  }

  function import_post2cat() {
    		
    $tpost2cat = explode("\n", $this->getuploadeddata());
    
    for ($i = 1; $i < count($tpost2cat); $i++) {
      list ($original_cat_id, $original_post_id) = explode("\";\"", $tpost2cat[$i]);
      $original_cat_id = trim($original_cat_id, "\"");
      $original_post_id = trim($original_post_id, "\"");
      $this->post2cat[$original_post_id] = $original_cat_id;
    }
    
    echo '<p>'.__('Relazioni Post-Categoria importate...').'</p>';
  }
  
  function import_posts($iterator) {
    
    $tposts = explode("\n", $this->getuploadeddata());
    
    for ($i = 1; $i < count($tposts); $i++) {
      list ($original_post_id, $user_id, $title, $vote1, $format, $mood, $publish, $visible, $comments, $trackback, $vote2, $numofvotes, $origip, $numofchars, $sent, $showcomments, $date, $realdate, $smiles) = explode("\";\"", $tposts[$i]);
      $original_post_id = trim($original_post_id, "\"");
      $user_id = trim($user_id, "\"");
      $title = trim($title, "\"");
      $publish = trim($publish, "\"");
      $visible = trim($visible, "\"");
      $sent = trim($sent, "\"");
      $showcomments = trim($showcomments, "\"");
      $date = trim($date, "\"");
      $realdate = trim($realdate, "\"");
      
      $datetouse = "";
      if ($realdate == 0) {
        $datetouse = $date;
      } else {
        $datetouse = $realdate;
      }
      
      $this->posts[$original_post_id] = array($user_id, $title, $publish, $visible, $sent, $showcomments, $datetouse);      
    }
    $this->totalposts = count ($this->posts);
  }
  
  function import_posts_text($iterator, $fn, $pl) {

    $this->file = base64_decode($fn)."/posts.txt";
    $this->import_posts($iterator);
    
    $this->file = base64_decode($fn)."/posts_text.txt";
    $tpostst = explode("\n", $this->getuploadeddata());
    
    $postslist = unserialize($pl);
    
    for ($i = ($iterator+1); $i < $iterator + $this->post_step; $i++) {
    
      if ($i <= $this->totalposts) {
      
      list ($original_post_id, $post_text) = explode("\";\"", $tpostst[$i]);
      $original_post_id = trim($original_post_id, "\"");
      $post_text = $this->preparetext(trim($post_text, "\""));
      
      $apost = $this->posts[$original_post_id];
    
      $year = substr($apost[6], 0, 4);
      $month = substr($apost[6], 4, 2);
      $day = substr($apost[6], 6, 2);
      $hour = substr($apost[6], 8, 2);
      $min = substr($apost[6], 10, 2);
      $sec = substr($apost[6], 12, 2);

      $post_author = $this->users[$apost[0]];
      $post_date = "$year-$month-$day $hour:$min:$sec";
      $post_date_gmt = get_gmt_from_date("$post_date");
      $post_content = $post_text;
      $post_title = $this->preparetext($apost[1]);
      $post_status = "";
      if ($apost[3]==0) {
        $post_status = "private";
      } else {
        if ($apost[2]==0) {
          $post_status = "draft";
        } else {
          $post_status = "publish";
        }
      }
      $comment_status = "";
      if ($apost[5]==0) {
        $comment_status = "closed";
      } else {
        $comment_status = "open";
      }
      
      $post_id = post_exists($post_title, $post_content, $post_date);
      if (!($post_id)) {
        $postdata = compact('post_author', 'post_date', 'post_date_gmt', 'post_content', 'post_title', 'post_status', 'comment_status');
        $post_id = wp_insert_post($postdata);  
        echo '<p>'.__('Importato '.$post_title.' scritto il '.$post_date.'</p>');
      } else {
        echo '<p>'.__('Tralasciato '.$post_title.' scritto il '.$post_date.' (gi&agrave; esistente)</p>');
      }
      
      $postslist[$original_post_id] = (int)$post_id;
      
      }
    }
    
    $npl = serialize($postslist);
        
    if ($i < $this->totalposts) {
      echo '<p>'.__('<a href=?import=iobloggo&amp;step=2&amp;fn='.$fn.'&amp;iterator='.($iterator + $this->post_step).'&amp;pl='.$npl.'>Prosegui importando i posts</a></p>');
    } else {
      echo '<p>'.__('Importazione dei post finita! <a href=?import=iobloggo&amp;step=3&amp;fn='.$fn.'&amp;pl='.$npl.'>Prosegui importando le relazioni Post-Categoria</a>');
    }
  }
  
  function import_posts_to_cats($fn, $pl) {
      
    $this->file = base64_decode($fn)."/categorie.txt";
    $this->import_categories();
    
    $this->file = base64_decode($fn)."/post_categorie.txt";
    $tpost2cats = explode("\n", $this->getuploadeddata());
    
    $postslist = unserialize($pl);
    
    for ($i = 1; $i < count($tpost2cats); $i++) {
      list ($cat_id, $post_id) = explode("\";\"", $tpost2cats[$i]);
      $cat_id = trim($cat_id, "\"");
      $post_id = trim($post_id, "\"");
      if ($this->categories[$cat_id] && $postslist[$post_id]) {
        wp_set_post_categories($postslist[$post_id], array_merge(wp_get_post_categories($postslist[$post_id]), array($this->categories[$cat_id])));
      }
    }
    
    echo '<p>'.__('Relazioni Post-Categoria importate! <a href=?import=iobloggo&amp;step=4&amp;fn='.$fn.'&amp;&pl='.$pl.'>Prosegui importando i commenti</a>').'</p>';
  }
  
  function import_comments($fn, $pl, $iterator) {
    
    $this->file = base64_decode($fn)."/commenti.txt";
    $tcomments = explode("\n", $this->getuploadeddata());
    
    $postslist = unserialize($pl);
    
    for ($i = ($iterator+1); $i < $iterator + $this->comments_step; $i++) {
      if (($i <= count($tcomments)) && ($tcomments[$i] != "")) {
        list ($post_id, $comment_author, $comment_author_email, $comment_author_url, $date, $comment_content) = explode("\";\"", $tcomments[$i]);
        $post_id = trim($post_id, "\"");
        $comment_author = $this->preparetext(trim($comment_author, "\""));
        $comment_author_email = trim($comment_author_email, "\"");
        $comment_author_url = trim($comment_author_url, "\"");
        $date = trim($date, "\"");
        $comment_content = $this->preparetext(trim($comment_content, "\""));
        
        $year = substr($date, 0, 4);
        $month = substr($date, 4, 2);
        $day = substr($date, 6, 2);
        $hour = substr($date, 8, 2);
        $min = substr($date, 10, 2);
        $sec = substr($date, 12, 2);

        $comment_date = "$year-$month-$day $hour:$min:$sec";        
        $comment_post_ID = $postslist[$post_id];
        $comment_author_IP = '127.0.0.1';
        $comment_approved = 1;
        
        if (!comment_exists($comment_author, $comment_date)) {
          $commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_url', 'comment_author_email', 'comment_author_IP', 'comment_date', 'comment_content', 'comment_approved');
          $commentdata = wp_filter_comment($commentdata);
					wp_insert_comment($commentdata);
					echo '<p>'.__('Importato il commento di '.$comment_author.' inserito il '.$comment_date.'</p>');
				} else {
          echo '<p>'.__('Tralasciato il commento di '.$comment_author.'\' inserito il '.$comment_date.' (gi&agrave; esistente)</p>');
        }
				
      }
    }
    
    if ($i < count($tcomments)) {
      echo '<p>'.__('<a href=?import=iobloggo&amp;step=4&amp;fn='.$fn.'&amp;iterator='.($iterator + $this->comments_step).'&amp;pl='.$pl.'>Prosegui importando i commenti</a></p>');
    } else {
      echo '<p>'.__('Importazione dei commenti terminata! <a href=?import=iobloggo&amp;step=5&amp;fn='.$fn.'&amp;pl='.$pl.'>Prosegui importando i trackbacks</a>');
    }
    
  }
  
  function import_trackbacks($fn, $pl, $iterator) {
    $this->file = base64_decode($fn)."/trackback.txt";
    $ttrackbacks = explode("\n", $this->getuploadeddata());
    
    $postslist = unserialize($pl);
    
    for ($i = ($iterator+1); $i < $iterator + $this->trackbacks_step; $i++) {
      if (($i <= count($ttrackbacks)) && ($ttrackbacks[$i] != "")) {
        list ($post_id, $post_title, $comment_content, $comment_author_url, $comment_author, $comment_date) = explode("\";\"", $ttrackbacks[$i]);
        $post_id = trim($post_id, "\"");
        $post_title = $this->preparetext(trim($post_title, "\""));
        $comment_content = $this->preparetext(trim($comment_content, "\""));
        $comment_author_url = trim($comment_author_url, "\"");
        $comment_author = $this->preparetext(trim($comment_author, "\""));
        $comment_date = trim($comment_date, "\"");
        
        $comment_post_ID = $postslist[$post_id];
        $comment_author_IP = '127.0.0.1';
        $comment_approved = 1;
        $comment_author_email = '';
        $comment_type = 'trackback';
        
        $comment_content = "<strong>$post_title</strong>\n\n$comment_content";
        
        if (!comment_exists($comment_author, $comment_date)) {
          $commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_url', 'comment_author_email', 'comment_author_IP', 'comment_date', 'comment_content', 'comment_type', 'comment_approved');
          $commentdata = wp_filter_comment($commentdata);
					wp_insert_comment($commentdata);
					echo '<p>'.__('Importato il trackback di '.$comment_author.' inserito il '.$comment_date.'</p>');
        } else {
          echo '<p>'.__('Tralasciato il trackback di '.$comment_author.'\' inserito il '.$comment_date.' (gi&agrave; esistente)</p>');
        }
      }
    }
    
    if ($i < count($ttrackbacks)) {
      echo '<p>'.__('<a href=?import=iobloggo&amp;step=5&amp;fn='.$fn.'&amp;iterator='.($iterator + $this->trackbacks_step).'&amp;pl='.$pl.'>Prosegui importando trackbacks</a></p>');
    } else {
      echo '<p>'.__('Importazione dei trackback finita!').'</p>';
      echo '<h3>'.sprintf(__('All done. <a href="%s">Have fun!</a>'), get_option('home')).'</h3>';
    }
    
  }
  
  function uploaddata() 
  {
    $file = wp_import_handle_upload();
		if ( isset($file['error']) ) {
			echo $file['error'];
			return;
		}
				
    $archive = new PclZip($file['file']);
    
    if ($archive->extract(PCLZIP_OPT_PATH, dirname($file['file'])) == 0) {
      echo '<p>'.__('Impossibile decomprimere il tuo file. Questo &#232; l\'errore: '.$archive->errorInfo(true)).'</p>';
    }
    
    $this->file = dirname($file['file'])."/utenti.txt";
    $this->import_users();
        
    echo '<p>'.__('Sono stati importati i primi dati. Per proseguire con il processo <a href=?import=iobloggo&amp;step=2&amp;fn='.base64_encode(dirname($file['file'])).'>clicca qui</a>').'</p>';
    
    wp_import_cleanup($file['id']);
    
  }
  
  function dispatch() {
		if (empty ($_GET['step']))
			$step = 0;
		else
			$step = (int) $_GET['step'];

		$this->header();
		
		switch ($step) {
			case 0 :
				$this->greet();
				break;
			case 1 :
			  $this->uploaddata();
			  break;
			case 2 :
			  if (empty ($_GET['iterator']))
			    $iterator = 0;
		    else
			    $iterator = (int) $_GET['iterator'];
			  if (empty ($_GET['fn']))
			    $fn = 0;
			  else
			    $fn = $_GET['fn'];
			  if (empty ($_GET['pl'])) {
			    $emptyarray = array();
			    $pl = serialize($emptyarray);
			  }
			  else
			    $pl = $_GET['pl'];
		    			  
			  $this->import_posts_text($iterator, $fn, $pl);
			  break;
			case 3 :
			  if (empty ($_GET['fn']))
			    $fn = 0;
			  else
			    $fn = $_GET['fn'];
			  if (empty ($_GET['pl'])) {
			    $emptyarray = array();
			    $pl = serialize($emptyarray);
			  }
			  else
			    $pl = $_GET['pl'];
		    			  
			  $this->import_posts_to_cats($fn, $pl);
			  break;
			case 4 :
			  if (empty ($_GET['iterator']))
			    $iterator = 0;
		    else
			    $iterator = (int) $_GET['iterator'];  
			  if (empty ($_GET['fn']))
			    $fn = 0;
			  else
			    $fn = $_GET['fn'];
			  if (empty ($_GET['pl'])) {
			    $emptyarray = array();
			    $pl = serialize($emptyarray);
			  }
			  else
			    $pl = $_GET['pl'];
		    			  
			  $this->import_comments($fn, $pl, $iterator);
			  break;
			case 5 :
			  if (empty ($_GET['iterator']))
			    $iterator = 0;
		    else
			    $iterator = (int) $_GET['iterator'];  
			  if (empty ($_GET['fn']))
			    $fn = 0;
			  else
			    $fn = $_GET['fn'];
			  if (empty ($_GET['pl'])) {
			    $emptyarray = array();
			    $pl = serialize($emptyarray);
			  }
			  else
			    $pl = $_GET['pl'];
		    
			  $this->import_trackbacks($fn, $pl, $iterator);
			  break;
		}		
		
		$this->footer();
	}

  function IoBloggo_Import() {
		// hi mom!
	}
}

$iobloggo_import = new IoBloggo_Import();

register_importer('iobloggo', 'IoBloggo', __('Importa un blog da IoBloggo'), array ($iobloggo_import, 'dispatch'));

?>
